# Copyright 2017 Red Hat, Inc.
#
# This work is licensed under the GNU GPLv2 or later.
# See the COPYING file in the top-level directory.

from ..xmlbuilder import XMLBuilder, XMLChildProperty, XMLProperty


XMLBuilder.register_namespace(
        "libosinfo", "http://libosinfo.org/xmlns/libvirt/domain/1.0")

XMLBuilder.register_namespace("group", "http://astralinux.ru/group")

XMLBuilder.register_namespace("backup", "http://astralinux.ru/backup")


class _XMLNSLibosinfo(XMLBuilder):
    XML_NAME = "libosinfo:libosinfo"

    os_id = XMLProperty("./libosinfo:os/@id")
    label = XMLProperty("./libosinfo:os/@label")


class _XMLNSGroup(XMLBuilder):
    XML_NAME = "group:group"

    name = XMLProperty("./group:group/@name")


class _XMLNSBackup(XMLBuilder):
    XML_NAME = "backup:backup"

    schedule = XMLProperty("./backup:backup/@schedule")
    repeat = XMLProperty ("./backup:backup/@repeat")
    folder = XMLProperty("./backup:backup/@folder")
    type = XMLProperty("./backup:backup/@type")
    threshold = XMLProperty("./backup:backup/@threshold")
    excluded = XMLProperty("./backup:backup/@excluded")
    compress = XMLProperty("./backup:backup/@compress")
    included = XMLProperty("./backup:backup/@included")
    encryption_key = XMLProperty("./backup:backup/@encryption-key")
    hash = XMLProperty("./backup:backup/@hash")


class DomainMetadata(XMLBuilder):
    """
    Class for generating <metadata> XML
    """
    XML_NAME = "metadata"

    libosinfo = XMLChildProperty(_XMLNSLibosinfo, is_single=True)
    group = XMLChildProperty(_XMLNSGroup, is_single=True)
    backup = XMLChildProperty(_XMLNSBackup, is_single=True)
